#include <DualWheelTruck.h> // Подключение библиотеки <DualWheelTruck.h> для работы с моторами

#define LEFT_LED 6 // Назначение пина, к которому подключен левый светодиод
#define RIGHT_LED 11 // Назначение пина, к которому подключен правый светодиод
#define BUTTON_REJIM 5 // Назначение пина, к которому подключена тактовая кнопка выбора режима работы
#define BUTTON_START 13 // Назначение пина, к которому подключена тактовая кнопка запуска робота
#define ENCODER_LEFT 9 // Назначение пина, к которому подключен левый энкодер
#define ENCODER_RIGHT 10 // Назначение пина, к которому подключен правый энкодер

#define r_korpus 68 // Б.1 - Объявление константы r_korpus (радиус корпуса робота) с значением 68
#define d_koles 64 // Б.1 - Объявление константы d_koles (диаметр колеса) с значением 64
#define okr_koles 3.14*d_koles // Б.2 - Объявление константы okr_koles (длина окружности колеса) с значением 3.14*d_koles
#define disk_sector 36 // Б.1 - Объявление константы disk_sector (количество секторов на черно-белом диске) с значением 36
float rastojan=okr_koles/disk_sector; // Б.2 - Объявление переменной rastojan (расстояние, проходимо колесом при повороте на один сектор черно-белого диска) и присвоение ей значения okr_koles/disk_sector
float cirkle_distance=2*r_korpus*3.14; // Б.2 - Объявление переменной cirkle_distance (длина окружности при повороте робота) и присвоение ей значения 2*r_korpus*3.14

bool button_state; // Объявление переменной button_state
bool robot_state=false; // Б.1 - Объявление переменной robot_state и присвоение ей значения false
bool right_encoder_state; // Объявление переменной right_encoder_state
bool left_encoder_state; // Объявление переменной left_encoder_state
bool right_encoder_state_was; // Объявление переменной right_encoder_state_was
bool left_encoder_state_was; // Объявление left_encoder_state_was left_encoder_state

int rejim=4; // Б.1 - Объявление переменной rejim и присвоение ей значения 4
int speeds=100; // Б.1 - Объявление переменной speeds и присвоение ей значения 100
int counter; // Объявление переменной counter
int counter_r; // Объявление переменной counter_r
int counter_l; // Объявление переменной counter_l

void button_read(); // Объявление функции обработки состояния кнопки запуска
void zapusk(); // Объявление функции подготовки робота к работе
void perecklychenie(); // Объявление функции, осуществляющий отсчет переключений энкодеров
void rotates_one(); // Объявление функции поворота робота по часовой стрелке
void rotates_two(); // Объявление функции поворота робота против часовой стрелки
void go_forward(); // Объявление функции прямолинейного движения робота
void reverse(); // Объявление функции, в процессе выполнения которой робот проедет вперед, развернется и приедет обратно
void molnia(); // Объявление функции, в процессе выполнения которой траекторией движения робота будет молния
void square(); // Объявление функции, в процессе выполнения которой траекторией движения робота будет квадрат

DCMotor* motor_right; // Инициализация мотора и присвоение ему имени motor_right
DCMotor* motor_left; // Инициализация мотора и присвоение ему имени motor_left

void setup() {
Board::vertor_STM(); // Объявление типа используемого контроллера - vertor_STM

motor_right = new DCMotor(1, 0, true, 5); // Настройка мотора motor_right с применением функции DCMotor(a, b, c, d): подключен к клеммнику 1, прямая полярность подключения мотора, инерционность 5
motor_left = new DCMotor(0, 0, false, 5); // Настройка мотора motor_left с применением функции DCMotor(a, b, c, d): подключен к клеммнику 0, обратная полярность подключения мотора, инерционность 5

motor_right->stop(false); // Команда на остановку вращения мотора motor_right
motor_left->stop(false); // Команда на остановку вращения мотора motor_left
 
pinMode (LEFT_LED,OUTPUT); // Настройка пина LEFT_LED на вывод
pinMode (RIGHT_LED,OUTPUT); // Настройка пина RIGHT_LED на вывод
pinMode (BUTTON_REJIM,INPUT); // Настройка пина BUTTON_REJIM на ввод
pinMode (BUTTON_START,INPUT); // Настройка пина BUTTON_START на ввод
pinMode (ENCODER_LEFT,INPUT); // Настройка пина ENCODER_LEFT на ввод
pinMode (ENCODER_RIGHT,INPUT); // Настройка пина ENCODER_RIGHT на ввод

right_encoder_state_was=digitalRead(ENCODER_RIGHT); // Б.3,4 - Сохранение состояния на пине ENCODER_RIGHT в переменную right_encoder_state_was
left_encoder_state_was=digitalRead(ENCODER_LEFT); // Б.3,4 - Сохранение состояния на пине ENCODER_LEFT в переменную left_encoder_state_was
}

void loop() {  
  button_state=digitalRead(BUTTON_REJIM); // Б.5 - Сохранение состояния на пине BUTTON_REJIM в переменную button_state
  if(button_state==0) // Б.6 - Если значение переменной button_state равно 0, то 
  {
     rejim++; // Б.7 - Увеличение значения переменной rejim на 1     
     do 
     {
      button_state=digitalRead(BUTTON_REJIM); // Б.8 - Сохранение состояния на пине BUTTON_REJIM в переменную button_state
     }
      while(button_state==0); // Б.9 - Цикл do while() выполнять до тех пор, пока значение переменной button_state равно 0
  } 
  
  if(rejim==2) // Б.10 - Если значение переменной rejim равно 2, то 
  {
  digitalWrite(LEFT_LED,HIGH); // Б.11 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"  
  digitalWrite(RIGHT_LED,LOW); // Б.11 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"  
  }
  else if(rejim==3) // Б.12 - Если значение переменной rejim равно 3, то 
  {  
  digitalWrite(LEFT_LED,HIGH); // Б.13 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"  
  digitalWrite(RIGHT_LED,HIGH); // Б.13 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"  
  }
  else if(rejim==4) // Б.14 - Если значение переменной rejim равно 4, то 
  {
  rejim=1; // Б.15 - Присвоение переменной rejim значения 1   
  digitalWrite(LEFT_LED,LOW);  // Б.16 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
  digitalWrite(RIGHT_LED,HIGH);  // Б.16 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"  
  }
  
  button_read(); // Б.17 - Вызов функции обработки состояния кнопки запуска

if(robot_state==true) // Б.18 - Если значение переменной robot_state равно true, то начать выполнение инструкций в скобках 
{
  zapusk(); // Б.19 - Вызов функции подготовки робота к работе
  switch(rejim){ // Выполнение инструкций в зависимости от значения переменной rejim
    case 1: // Б.20 - Выполнение инструкции, если значение переменной rejim равно 1
    reverse();  // Б.21 - Вызов функции, в процессе выполнения которой робот проедет вперед, развернется и приедет обратно
    break; // Прерывание дальнейшего выполнения оператора switch
    case 2: // Б.22 - Выполнение инструкции, если значение переменной rejim равно 2
    molnia(); // Б.23 - Вызов функции, в процессе выполнения которой траекторией движения робота будет молния
    break; // Прерывание дальнейшего выполнения оператора switch
    case 3: // Б.24 - Выполнение инструкции, если значение переменной rejim равно 3
    square();  // Б.27 - Вызов функции, в процессе выполнения которой траекторией движения робота будет квадрат
    break; // Прерывание дальнейшего выполнения оператора switch
  }
     
    robot_state=false; // Б.25 - Присвоение переменной robot_state значения false
    motor_right->stop(false); // Б.26 - Команда на остановку вращения мотора motor_right
    motor_left->stop(false); // Б.26 - Команда на остановку вращения мотора motor_left
    if (rejim==1) // Б.28 - Если значение переменной rejim равно 1, то выполнить инструкцию в скобках
    {
      rejim=4; // Б.29 - Присвоение переменной rejim значения 4
    }
}      
}

void button_read()
{
  button_state=digitalRead(BUTTON_START); // Б.17.1 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.17.2 - Если значение переменной button_state равно 0, то 
  {
  delay(10); // Б.17.3 - Ожидание 0,01 с
  button_state=digitalRead(BUTTON_START); // Б.17.4 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.17.5 - Если значение переменной button_state равно 0, то 
  {
  do 
  {
   button_state=digitalRead(BUTTON_START); // Б.17.6 - Сохранение состояния на пине BUTTON_START в переменную button_state
  }
  while(button_state==0); // Б.17.7 - Цикл do while() выполнять до тех пор, пока значение переменной button_state равно 0
   robot_state=true; // Б.17.8 - Присвоение переменной robot_state значение true   
  }
  }
}

void zapusk()
{
  counter=0; // Б.19.1 - Присвоение переменной counter значения 0
  while(counter<3) // Б.19.2 - Инициализация цикла While()
                   // Выполнение цикла, пока значение переменной counter меньше 3                                     
  {
   digitalWrite(LEFT_LED,HIGH); // Б.19.3 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"
   digitalWrite(RIGHT_LED,HIGH); // Б.19.3 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"
   delay(500); // Б.19.4 - Ожидание 0,5 секунды
   digitalWrite(LEFT_LED,LOW); // Б.19.5 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
   digitalWrite(RIGHT_LED,LOW); // Б.19.5 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"
   delay(500); // Б.19.6 - Ожидание 0,5 секунд
   counter=counter+1; // Б.19.7 - Увеличение значения переменной counter на 1
  }     
}

void rotates_one(float znachenie) // Функция, реализующая разворот робота на угол znachenie по часовой стрелке
{
   counter_r=int((znachenie*cirkle_distance)/(360*rastojan)); // Б.ЧС.1 - Присвоение переменной counter_r значения количества переключений сектора черно-белого диска, расчитанного по формуле: znachenie*cirkle_distance)/(360*rastojan)
   motor_right->backward(100); // Б.ЧС.2 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
   motor_left->forward(100); // Б.ЧС.2 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
   perecklychenie(); // Б.ПП - Вызов функции, осуществляющей подсчет количества переключений правого и левого черно-белых дисков энкодера   
}

void rotates_two(float znachenie) // Функция, реализующая разворот робота на угол znachenie против часовой стрелки
{
   counter_r=int((znachenie*cirkle_distance)/(360*rastojan)); // Б.СЧ.1 - Присвоение переменной counter_r значения количества переключений сектора черно-белого диска, расчитанного по формуле: znachenie*cirkle_distance)/(360*rastojan)
   motor_right->forward(100); // Б.СЧ.2 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
   motor_left->backward(100); // Б.СЧ.2 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении  
   perecklychenie(); // Б.ПП - Вызов функции, осуществляющей подсчет количества переключений правого и левого черно-белых дисков энкодера
}

void go_forward(float znachenie) // Функция, реализующая движение робота прямо на расстояние znachenie мм
{
  counter_r=int(znachenie/rastojan); // Б.МП.1 - Присвоение переменной counter_r значения количества переключений сектора черно-белого диска, расчитанного по формуле: znachenie/rastojan
  motor_right->forward(100); // Б.МП.2 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->forward(100); // Б.МП.2 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении  
  perecklychenie(); // Б.ПП - Вызов функции, осуществляющей подсчет количества переключений правого и левого черно-белых дисков энкодера
}
void perecklychenie() // Функция поворота робота
{    
  counter_l=counter_r; // Б.ПП.1 - Присвоение переменной counter_l значение переменной counter_r

  while(counter_r>0||counter_l>0) // Б.ПП.2 - Цикл While() выполнять до тех пор, пока значение переменной counter_r больше 0 или значение перменной counter_l больше 0
  {  
  right_encoder_state=digitalRead(ENCODER_RIGHT); // Б.ПП.3 - Сохранение состояния на пине ENCODER_RIGHT в переменную right_encoder_state
  left_encoder_state=digitalRead(ENCODER_LEFT); // Б.ПП.3 - Сохранение состояния на пине ENCODER_LEFT в переменную left_encoder_state
  
  if(right_encoder_state!=right_encoder_state_was) // Б.ПП.4 - Если значение переменной right_encoder_state не совпадает со значением переменной right_encoder_state_was, то выполнять инструкции в скобках
  {    
    counter_r=counter_r-1; // Б.ПП.5 - Уменьшение значения переменной counter_r на 1    
    
    if(counter_r==0) // Б.ПП.6 - Если значение переменной counter_r равно 0, то выполнять инструкции в скобках
    {
      motor_right->stop(false); // Б.ПП.7 - Команда на остановку вращения мотора motor_right
    }
  }
    if(left_encoder_state!=left_encoder_state_was) // Б.ПП.8 - Если значение переменной left_encoder_state не совпадает со значением переменной left_encoder_state_was, то выполнять инструкции в скобках
  {
    counter_l=counter_l-1; // Б.ПП.9 - Уменьшение значения переменной counter_l на 1    
    if(counter_l==0) // Б.ПП.10 - Если значение переменной counter_l равно 0, то выполнять инструкции в скобках
    {
      motor_left->stop(false); // Б.ПП.11 - Команда на остановку вращения мотора motor_left
    }
  }
  delay(5); // Б.ПП.12 - Ожидание 0,005 секунд
  right_encoder_state_was=right_encoder_state; // Б.ПП.13 - Присвоение переменной right_encoder_state_was значения переменной right_encoder_state
  left_encoder_state_was=left_encoder_state; // Б.ПП.13 - Присвоение переменной left_encoder_state_was значения переменной left_encoder_state
}
}

void reverse()
{    
  go_forward(300); // Б.300.МП - Проехать прямо на 300 мм
  rotates_one(180); // Б.180.ЧС - Повернуться на 180 градусов по часовой стрелке
  go_forward(300); // Б.300.МП - Проехать прямо на 300 мм
  rotates_one(180); // Б.180.ЧС - Повернуться на 180 градусов по часовой стрелке
}

void molnia()
{  
  go_forward(100); // Б.100.МП - Проехать прямо на 100 мм
  rotates_two(45); // Б.45.СЧ - Повернуться на 90 градусов против часовой стрелке
  go_forward(100); // Б.100.МП - Проехать прямо на 100 мм
  rotates_one(90); // Б.90.ЧС - Повернуться на 90 градусов по часовой стрелке
  go_forward(200); // Б.200.МП - Проехать прямо на 200 мм
  rotates_two(90); // Б.90.СЧ - Повернуться на 90 градусов против часовой стрелке
  go_forward(100); // Б.100.МП - Проехать прямо на 100 мм
  rotates_one(45); // Б.45.ЧС - Повернуться на 90 градусов по часовой стрелке  
}

void square()
{
  go_forward(200); // Б.200.МП - Проехать прямо на 200 мм
  rotates_one(90); // Б.90.ЧС - Повернуться на 90 градусов по часовой стрелке
  go_forward(200); // Б.200.МП - Проехать прямо на 200 мм
  rotates_one(90); // Б.90.ЧС - Повернуться на 90 градусов по часовой стрелке
  go_forward(200); // Б.200.МП - Проехать прямо на 200 мм
  rotates_one(90); // Б.90.ЧС - Повернуться на 90 градусов по часовой стрелке
  go_forward(200); // Б.200.МП - Проехать прямо на 200 мм
  rotates_one(90); // Б.90.ЧС - Повернуться на 90 градусов по часовой стрелке
}
